<script lang="ts">
import Vue from 'vue';

interface Item {
  title: string;
  text: string;
  link: {
    text: string;
    href: string;
    data_ga_name: string;
    data_ga_location: string;
  };
  icon: {
    name: string;
    variant: string;
  };
}

interface Content {
  title: string;
  description: string;
  button: {
    text: string;
    href: string;
    dataGaName: string;
    dataGaLocation: string;
    icon: {
      name: string;
      variant: string;
    };
  };
  items: Array<Item>;
}

export default Vue.extend({
  props: {
    data: {
      type: Object as () => Content,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <section class="showcase-wrapper">
    <SlpContainer>
      <div class="slp-flex heading">
        <div>
          <SlpTypography tag="h2" variant="heading2-bold">
            {{ data.title }}
          </SlpTypography>
          <SlpTypography tag="p" variant="heading5">
            {{ data.description }}
          </SlpTypography>
        </div>

        <SlpButton
          variant="tertiary"
          :href="data.button.href"
          :data-ga-name="data.button.dataGaName"
          >{{ data.button.text || 'More CI/CD resources' }}
          <SlpIcon
            v-if="data.button.icon"
            :name="data.button.icon.name"
            :variant="data.button.icon.variant"
          />
        </SlpButton>
      </div>
      <SlpRow ref="cards" class="slp-mt-48 slp-mb-64 cards">
        <SlpColumn v-for="item in data.items" :key="item.title" :cols="4">
          <!-- WITH LINK -->
          <a
            v-if="item.link"
            class="showcase-card"
            :href="item.link.href"
            :data-ga-name="item.link.data_ga_name"
            :data-ga-location="item.link.data_ga_location"
          >
            <div class="content">
              <SlpIcon
                v-if="item.icon"
                class="slp-mb-24"
                :name="item.icon.name"
                :variant="item.icon.variant"
                size="md"
                slp-color="primary-200"
              />
              <div class="slp-mb-16">
                <SlpTypography
                  tag="h3"
                  variant="body1-bold"
                  :class="item.link.text && 'showcase-card__link'"
                >
                  {{ item.title }}
                </SlpTypography>
                <SlpTypography tag="p" variant="body3">
                  {{ item.text }}
                </SlpTypography>
              </div>

              <span v-if="item.link.text"
                >{{ item.link.text }}
                <SlpIcon
                  class="slp-ml-8"
                  name="chevron-lg-right"
                  variant="product"
                  alt="Chevron Right Icon"
              /></span>
              <SlpIcon
                v-else
                name="arrow-right"
                variant="product"
                size="sm"
                class="arrow-icon"
              />
            </div>
          </a>
          <!-- WITHOUT LINK -->
          <div v-else class="showcase-card">
            <div>
              <SlpIcon
                v-if="item.icon"
                :name="item.icon.name"
                :variant="item.icon.variant"
                size="md"
                class="slp-mb-24"
              />
              <SlpTypography tag="h3" variant="heading5-bold">
                {{ item.title }}
              </SlpTypography>
              <SlpTypography tag="p" variant="body1">
                {{ item.text }}
              </SlpTypography>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.heading {
  flex-direction: column;
  align-items: flex-start;

  @media (min-width: $breakpoint-md) {
    flex-direction: row;
    align-items: flex-end;
    justify-content: space-between;
  }
}

.content {
  height: 100%;
  display: flex;
  flex-direction: column;
}
.arrow-icon {
  margin-top: auto;
  color: black;
}
.showcase-wrapper {
  background: $color-surface-800;
  padding: $spacing-96 0 $spacing-96;

  h2 {
    margin-bottom: $spacing-8;
  }

  .slp-col-md-4 {
    padding-right: $spacing-24;
    padding-bottom: $spacing-16;
  }
}

.showcase__gradient-header {
  background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
  height: 4px;
  width: 95px;
  border-radius: 10px;
  margin-bottom: $spacing-16;
}

.icon {
  margin-bottom: $spacing-16;
}

.horizontal-scroll {
  display: none;
}

.cards {
  position: relative;
}

a.showcase-card:hover {
  border-radius: 0 0 100px 0;
}

.showcase-card {
  height: 320px;
  display: block;
  background: $color-surface-50;
  width: 100%;
  padding: $spacing-32 $spacing-24;
  transition: all 0.3s ease-in-out;
  position: relative;

  p,
  a,
  span {
    color: $color-text-300;
  }

  h3 {
    display: block;
    margin-bottom: $spacing-16;
    max-width: 318px;
    color: $color-text-300;
  }

  span {
    display: flex;
    flex: 1 0 auto;
    align-items: center;
    font-weight: $font-weight-bold;
    font-size: $text-body-2-bold;
    margin-top: $spacing-16;

    svg {
      margin-left: 10px;
    }
  }

  &__link {
    color: $color-text-300;
  }
}

@media (max-width: 767px) {
  .showcase-wrapper .slp-col-md-4 {
    padding-right: 0;
  }

  .cards {
    flex-wrap: nowrap;
    overflow-x: scroll;
    margin-bottom: 0;

    scrollbar-width: none; // hides scrollbar on Firefox
    -ms-overflow-style: none; // hides scrollbar on IE 10+

    &::-webkit-scrollbar {
      // hides scrollbar on browsers that use that use Webkit (Chrome, Safari, Opera, etc)
      width: 0;
      height: 0;
      display: none;
    }
  }

  .showcase-card {
    height: 100%;
    width: 270px;
    margin-right: $spacing-16;
  }

  .horizontal-scroll {
    margin-top: $spacing-32;
    display: block;
  }
}
</style>
